<?php

/**
 * distribucion_planta_cargo actions.
 *
 * @package    nomina
 * @subpackage distribucion_planta_cargo
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class distribucion_planta_cargoActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'NO_DP_V',
        'RH_AP_DEN_EMP'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'RH_AP_DEN_EMP' =>
        array(
            'id_den_emp' => 'NO_DP_V'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'NO_DP_V' =>
        array(
            'id_dp' => 'id_dp',
            'id_mf' => 'id_mf',
            'id_ea' => 'id_ea',
            'nombre_inst' => 'nombre_inst',
            'codigo' => 'codigo',
            'titular' => 'titular',
            'encargado' => 'encargado',
            'id_den_emp' => 'id_den_emp',
            'id_sa_nom_tit' => 'id_sa_nom_tit',
            'id_sa_nom_enc' => 'id_sa_nom_enc',
            'id_cia' => 'id_cia',
            'id_cen_op' => 'id_cen_op',
            'centro' => 'centro',
            'adjunto' => 'adjunto',
            'area' => 'area',
            'nom_titular' => 'nom_titular',
            'nom_encarga' => 'nom_encarga',
            'naturaleza' => 'naturaleza',
            'componente' => 'componente',
            'asignacion_basica' => 'asignacion_basica'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'id_cia', 'id_cen_op', 'codigo'
    ); //campos para el ordenamiento de la consulta


    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * _filtroNull / para filtro de not null o null - type debe ser is - para todas las variables
     * TYPE NULL / para filtro de not null o null con el valor de campo desde gwt
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'NO_DP_V' =>
        array(
            'id_dp,a' => array('!=' => array(-1)),
            'id_dp,b' => array('=' => array('id_dp')),
            'id_mf' => array('=' => array('id_mf')),
            'id_ea' => array('=' => array('id_ea')),
            'id_den_emp' => array('=' => array('id_den_emp')),
            'id_cia' => array('=' => array('id_cia')),
            'id_cen_op' => array('=' => array('id_cen_op')),
            'titular' => array('=' => array('titular')),
            'encargado' => array('=' => array('encargado')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'RH_AP_DEN_EMP' =>
        array(
            'id_nat_em' => array('=' => array('id_nat_emp')),
            'id_planta_p' => array('=' => array('id_planta'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
        'NO_DP_V' =>
        array(
            //'num_doc' => array('LIKE' => array('input', '%')),
            'componente' => array('LIKEALLPLUS' => array('input', '%'))
        )
    ); // filtros de condicion or
    protected $query_qualifier = 'DISTINCT'; //Para eliminar filas repetidas

    /*
     * Variable manejo de log
     */
    //si es servicio para filtro agregar campo
    protected $filtro = 'Distribución Plantas';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    /**
     * Metodo para add para la aplicacion de descuentos sobre pagos - embargos
     *
     * @param sfWebRequest $request
     */
    public function executeAdd(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        //manejo de errores
        try {

            //variables obligatorias
            $id_dp = $request['id_dp'];
            $adjunto = $request['adjunto'];


            //sentencia sql
            $sql = <<<EOD
update rh_dp set adjunto = '$adjunto'
where id_dp = $id_dp
EOD;
            //ejecuta el sql
            CN_TABLE::executeSQL($sql);


            $this->list_data = array();
        } catch (Exception $e) {

            $this->status = 1;
            $this->mensajeError = "ERROR!!!";
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}